
import re
import time
from time import gmtime, strftime
import datetime
import termstatus
import sys
import math
import socket
import time
import pdb
import select
import struct
import termstatus
import netgpib
import termstatus
filetime = strftime("%d%m%Y-%H%M%S", gmtime()) # Date string for data file ; time in gmt(default)
#*************************************************
#EDIT SETTINGS HERE
#Edit these options carefully
#Undefined items may produce undefined or wrong
#results
#*************************************************

ipAddress       = "192.168.1.2"           # GPIB IP
gpibAddress     = int(16)                 # GPIB port
title           = "HP87653E"              # Name
filename        = filetime                # Add time to filename
memo            = "Data Read No preset"   # Extra info if needed
displayType     = "SMIC"                  # For text file header names ONLY
#*************************************************
# Create a netGPIB class object
#*************************************************
print('Connecting to '+str(ipAddress)+' ...'),
gpibObj=netgpib.netGPIB(ipAddress, gpibAddress, '\004',0)
print('done.')

#*************************************************
#Get a board serial number
#*************************************************
ser  = ""
serialString = "0"
while ser != 'y':
    serialString = raw_input ("enter a serial \n")
    ser          = raw_input ('SERIAL NUMBER -  ' + serialString + '\n' + 'enter [n] or [y] to continue \n')
print "Serial Saved"

# File names
# added filetime to file name
dataFileName=serialString+' '+filetime+'.txt'
print('Board Serial = '+serialString)
print('File time    = '+filetime)
print('Measurement data will be written into '+dataFileName)
print('Setting up parameters for the measurement...')

#*************************************************
#Send data to GPIB
#*************************************************

#gpibObj.command("PRES;")           # Preset the device and set for Single sweep
mine = gpibObj.query("OPC?;WAIT;")  # Wait for 8753 setup..
print str(mine)
gpibObj.command("FORM4;")           # Preset the device and set for Single sweep
gpibObj.command("SING;")            # Single sweep data
gpibObj.command("OUTPDATA;")        #
                                    # OUTPDATA- Outputs the error corrected data
                                    # from the active channel in reaMmaglnary pairs
                                    #
                                    # OUTPFORM - Outputs the formatted trace
                                    # data from the active channel in current display units.
analysisData2 = str(gpibObj.getData())   #store data
gpibObj.command("OUTPLIML;")             #frequency vector
analysisData  = str(gpibObj.getData())   #store data

startfrqRead = gpibObj.query("STAR?;")   #Read in the start frequency
stopfrqRead  = gpibObj.query("STOP?;")   #Read in the start frequency


#*************************************************
#Save data to file
#*************************************************
print('Writing measurement data to file...')
if title == "":
    title = filename
dataFile = open(dataFileName,'w')
dataFile.write('# HP8753E '+displayType+' Analysis\n')
dataFile.write('Title: '+title+'\n')
dataFile.write('Memo: '+memo+'\n')
dataFile.write('#---------- User Measurement Setup ------------\n')

dataFile.write('#---------- System read Setup ------------\n')
#dataFile.write('Number of points: '+traceRead +'\n')
dataFile.write('Start frequency : '+startfrqRead +'\n')
dataFile.write('Stopfrequency   : '+stopfrqRead +'\n')
dataFile.write('\n')
if displayType == "SMIC":
     dataFile.write('units: Degree ---------------------------------------   Frequency' +'\n')
elif displayType == "PHAS":
     dataFile.write('units: Degree ---------------------------------------   Frequency' +'\n')
elif displayType == "SMAILIN":
     dataFile.write('units: Degree ---------------------------------------   Frequency' +'\n')
elif displayType == "SMIMLOG":
     dataFile.write('units: Degree ---------------------------------------   Frequency' +'\n')
else : dataFile.write('units: unknown --------------------------------------- unknown' +'\n')
#*************************************************
# Trace Data 
#*************************************************
datastring =""

printlistA  = [] #ASCI Trace data parse into arrays of data at each new line
for i in range(len(analysisData2)):
      if analysisData2[i] != '\n':
         datastring+=analysisData2[i]
      else:
         printlistA.append(datastring)
         #dataFile.write(datastring +',' + '\n')
         datastring = ""

printlistB  = [] # Freqency vector
for i in range(len(analysisData)):
      if analysisData[i] != '\n':
         datastring+=analysisData[i]
      else:
         printlistB.append(datastring)
         #dataFile.write(datastring +',' + '\n')
         #print datastring
         datastring = ""
for i in range(len(printlistA)):
         #print (str(printlistA[i] + ', ' + printlistB[i] + '\n'))
         dataFile.write( str(printlistA[i] + ', ' + printlistB[i] + '\n'))

print('Done!')

#*************************************************
#Save data to file close file/gpib
#*************************************************'''
dataFile.close()
gpibObj.close()

