
import re
import time
from time import gmtime, strftime
import datetime
import termstatus
import sys
import math
import socket
import time
import pdb
import select
import struct
import termstatus
import netgpib
import termstatus

#*************************************************
#EDIT SETTINGS HERE
#Edit these options carefully
#Undefined items may produce undefined or wrong
#results
#*************************************************

ipAddress       = "192.168.1.2"     # GPIB IP
gpibAddress     = int(16)           # GPIB port

calibType       = "S11"             # Calib Type "Response" or "S11"
startFrq        = "1.99MHZ"      # start frq
stopFrq         = "2.04MHZ"      # stop frq
outputPwr       = "0.00"            # Output power in dBm


#*************************************************
# Create a netGPIB class object
#*************************************************
print('Connecting to '+str(ipAddress)+' ...'),
gpibObj=netgpib.netGPIB(ipAddress, gpibAddress, '\004',0)
print('done.')

#*************************************************
#Ask the user to short the ends/follow instructions
#*************************************************

print "Calibrating..."
gpibObj.command("PRES;")                        # Preset the device and set for Single sweep
mine = gpibObj.query("OPC?;WAIT;")              # Wait for 8753 setup.. OPC = Operation completed
gpibObj.command("POWE "+outputPwr+"DB;")        # Output Power
gpibObj.command("STAR "+startFrq+";")   # start frq
gpibObj.command("STOP "+stopFrq+";")    # stop frq

if calibType == "Response":   # Response Calib
      raw_input ('Short the cable ends, enter any key to continue\n')
      gpibObj.command("CALIRESP;")           # Response Calib         
      gpibObj.command("FWDT;")               # Selects FWD Transmition
      gpibObj.command("RESPDONE;")           # Completes the response calibration sequence.
      print "Response Calibration Complete!"
      
elif calibType == "S11":      #S11 Calib
      gpibObj.command("CALIS111;")
      raw_input ('CONNECT OPEN AT PORT 1, enter any key to continue\n')
      gpibObj.command("CLASS11A")           #Open reflection CAL     
      raw_input ('CONNECT SHORT AT PORT 1, enter any key to continue\n')
      gpibObj.command("CLASS11B;")          #Short reflection CAL
      raw_input ('CONNECT LOAD AT PORT 1, enter any key to continue\n')
      gpibObj.command("CLASS11C;")          # Load reflection CAL
      print "S11 Calibration Complete!"
else: print "Calibration Error!"   # Error, did you forget to specify a calib type?
gpibObj.close()








