
import re
import time
from time import gmtime, strftime
import datetime
import termstatus
import sys
import math
import socket
import time
import pdb
import select
import struct
import termstatus
import netgpib
import termstatus
filetime = strftime("%d%m%Y-%H%M%S", gmtime()) # Date string for data file ; time in gmt(default)
#*************************************************
#This is a file for basic transfer function measurements using the HP8753C
#EDIT SETTINGS HERE
#Edit these options carefully
#Undefined items may produce undefined or wrong
#results
#*************************************************

ipAddress       = "192.168.1.2" # GPIB IP
gpibAddress     = int(16)       # GPIB port
title           = "HP87653E"    # Name
filename        = filetime      # Add time to filename
memo            = ""            # Extra info if needed


#*************************************************
#Edit these setting for your application
#*************************************************
startFrq    ="30MHZ"      # start frq
stopFrq     ="100MHZ"      # stop frq
tracePoint  ="401"          # Trace Length 3,11,21,26,51,101,201,401,801
measMode    ="S21"          # Measure mode S11 S21 S12 S22
displayType ="SMIMLOG"         # Display Type
                            # SMIC    -Smith Chart,
                            # PHAS    -Phase ,  degrees
                            # SMAILIN -Linear magnitude,
                            # SMIMLOG -Log magnitude,  db
outputPwr   ="-20.00"          # Output power in dBm "-13.01" or "2.00"


#*************************************************
# Create a netGPIB class object
#*************************************************
print('Connecting to '+str(ipAddress)+' ...'),
gpibObj=netgpib.netGPIB(ipAddress, gpibAddress, '\004',0)
print('done.')

#*************************************************
#Get a board serial number
#*************************************************
ser  = ""
serialString = "0"
while ser != 'y':
    serialString = raw_input ("enter a serial \n")
    ser          = raw_input ('SERIAL NUMBER -  ' + serialString + '\n' + 'enter [n] or [y] to continue \n')
print "Serial Saved"

# File names
# added filetime to file name
dataFileName=serialString+' '+filetime+'.txt'
print('Board Serial = '+serialString)
print('File time    = '+filetime)
print('Measurement data will be written into '+dataFileName)
print('Setting up parameters for the measurement...')

#*************************************************
#Send data to GPIB
#*************************************************


#gpibObj.command("PRES;")                # Preset the device
mine = gpibObj.query("OPC?;WAIT;")
print str(mine)
gpibObj.command("POWE "+outputPwr+"DB;")# Output Power
gpibObj.command("FORM4;")               # Set analyzer for ASCII data format
gpibObj.command("STAR "+startFrq+";")   # start frq
gpibObj.command("STOP "+stopFrq+";")    # stop frq
#gpibObj.command("MENUMEAS;")           # Menu meas view
gpibObj.command(measMode+";")           # Measure mode S11 S21 S12 S22
#gpibObj.command("MENUFORM;")           # Format menu
gpibObj.command(displayType+";")        # Display Type
gpibObj.command("POIN "+tracePoint+";") # Trace Length 3,11,21,26,51,101,201,401,801,1601
gpibObj.command("SING;")                # Sweep type (SING = single)
gpibObj.command("OUTPDATA;")            #
                                        # OUTPDATA- Outputs the error corrected data
                                        # from the active channel in real/imaginary pairs
                                        #
                                        # OUTPFORM - Outputs the formatted trace
                                        # data from the active channel in current display units.
analysisData2 = str(gpibObj.getData())  #store data
gpibObj.command("OUTPLIML;")            #Output the frequency vector
analysisData = str(gpibObj.getData())   #store data
traceRead = gpibObj.query("POIN?;")     #Read in the default trace length
print str(mine)
startfrqRead = gpibObj.query("STAR?;")  #Read in the start frequency
print str(mine)
stopfrqRead = gpibObj.query("STOP?;")   #Read in the start frequency
print str(mine)
#mine = gpibObj.query("AVERO?;") #Averaging on?
#print str(mine)


#*************************************************
#Save data to file
#*************************************************
print('Writing measurement data to file...')
if title == "":
    title = filename
dataFile = open(dataFileName,'w')
dataFile.write('# HP8753E '+displayType+' Analysis\n')
dataFile.write('Title: '+title+'\n')
dataFile.write('Memo: '+memo+'\n')
dataFile.write('#---------- User Measurement Setup ------------\n')

dataFile.write('#---------- System read Setup ------------\n')
dataFile.write('Number of points: '+traceRead +'\n')
dataFile.write('Start frequency : '+startfrqRead +'\n')
dataFile.write('Stopfrequency   : '+stopfrqRead +'\n')
dataFile.write('Output Power    : '+outputPwr + ' Dbm'+'\n')
dataFile.write('\n')
if displayType == "SMIC":
     dataFile.write('units: real/imaginary -------------------------------   Frequency' +'\n')
if displayType == "PHAS":
     dataFile.write('units: Degree ---------------------------------------   Frequency' +'\n')
if displayType == "SMAILIN":
     dataFile.write('units: Linear Mag -----------------------------------   Frequency' +'\n')
if displayType == "SMIMLOG":
     dataFile.write('units: Log Mag --------------------------------------   Frequency' +'\n')

#*************************************************
# Trace Data 
#*************************************************
datastring =""

printlistA  = [] #ASCI Trace data parse into arrays of data at each new line
for i in range(len(analysisData2)):
      if analysisData2[i] != '\n':
         datastring+=analysisData2[i]
      else:
         printlistA.append(datastring)
         #dataFile.write(datastring +',' + '\n')
         datastring = ""

printlistB  = [] # Freqency vector
for i in range(len(analysisData)):
      if analysisData[i] != '\n':
         datastring+=analysisData[i]
      else:
         printlistB.append(datastring)
         #dataFile.write(datastring +',' + '\n')
         #print datastring
         datastring = ""
for i in range(len(printlistA)):
         dataFile.write( str(printlistA[i] + ', ' + printlistB[i] + '\n'))

print('Done!')

#*************************************************
#Save data to file close file/gpib
#*************************************************'''
dataFile.close()
gpibObj.close()

