#! /usr/bin/env python
#
# getgpibdata.py [-f filename] [-d devicename] [-b board#] [-a gpib_address]
#
# This script will get data from various GPIB devices and save the data into a data file.
# The name of the data file can be specified by '-f' option. If '-f myfile' is specified, 
# myfile.dat is the name of the data file. Also myfile.par will be created.
# The format of myfile.dat should be explained in myfile.par along with various measurement
# parameters.
# Yoichi Aso  Sep 9 2008

import re
import gpib
import sys
import math
from optparse import OptionParser
#mport curses
#import SR785
import AG4395A

#Parse options
parser = OptionParser()
parser.add_option("-f", "--file", dest="filename",
                  help="Output file name without an extension", default="data")
parser.add_option("-d", "--device",
                  dest="deviceName", default="AG4395A",
                  help="A GPIB device name. Default = SR785.")
parser.add_option("-a", "--address",
                  dest="pad", type="int",
                  help="GPIB device address")
parser.add_option("-b", "--board",
                  dest="bad", type="int",
                  help="GPIB board number")

(options, args) = parser.parse_args()

#Initialize curses
#stdscr = curses.initscr()
#curses.noecho()
#curses.cbreak()
#stdscr.keypad(1)

# open device
#if (options.bad != None)&(options.pad !=None):
   # stdscr.addstr('Opening device at board = '+str(options.bad)+', address = '+str(options.pad)+'\n')
   # stdscr.refresh()
    #device = gpib.dev(options.bad, options.pad)
#else:
    #device = gpib.find(options.deviceName)
    #stdscr.addstr('Opening device '+options.deviceName+'\n')
    #stdscr.refresh()

# open files
dataFileName=options.filename+'.dat'
paramFileName=options.filename+'.par'
dataFile = open(dataFileName,'w')
paramFile = open(paramFileName,'w')

print('Data will be written into '+dataFileName+'\n')
#stdscr.addstr('Parameters will be written into '+paramFileName+'\n')
#stdscr.refresh()

#Call suitable functions for getting data
if options.deviceName == 'AG4395A':
    AG4395A.getdata(device, dataFile, paramFile, stdscr)



